hpp-core: Steering method and distance functions

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Classes | Functions
Steering method and distance functions

## Classes
class | hpp::core::Distance
| Abstract class for distance between configurations. More...
class | hpp::core::distance::ReedsShepp
class | hpp::core::KinodynamicDistance
class | hpp::core::SteeringMethod
class | hpp::core::steeringMethod::CarLike
class | hpp::core::steeringMethod::Dubins
class | hpp::core::steeringMethod::Hermite
class | hpp::core::steeringMethod::Interpolated
class | hpp::core::steeringMethod::ReedsShepp
class | hpp::core::steeringMethod::Snibud
class | hpp::core::steeringMethod::Spline< _PolynomeBasis, _SplineOrder >
class | hpp::core::steeringMethod::Kinodynamic
class | hpp::core::steeringMethod::Straight
class | hpp::core::WeighedDistance

## Functions
std::vector< JointPtr_t > | hpp::core::steeringMethod::getWheelsFromParameter (const ProblemConstPtr_t &problem, const JointPtr_t &rz)
PathVectorPtr_t | hpp::core::steeringMethod::reedsSheppPathOrDistance (const DevicePtr_t &device, ConfigurationIn_t init, ConfigurationIn_t end, value_type extraLength, value_type rho, size_type xyId, size_type rzId, const std::vector< JointPtr_t > wheels, ConstraintSetPtr_t constraints, bool computeDistance, value_type &distance)
static StraightPtr_t | hpp::core::steeringMethod::Straight::create (const ProblemConstPtr_t &problem)
| Create instance and return shared pointer.
static StraightPtr_t | hpp::core::steeringMethod::Straight::createCopy (const StraightPtr_t &other)
| Copy instance and return shared pointer.
virtual SteeringMethodPtr_t | hpp::core::steeringMethod::Straight::copy () const
| Copy instance and return shared pointer.
virtual PathPtr_t | hpp::core::steeringMethod::Straight::impl_compute (ConfigurationIn_t q1, ConfigurationIn_t q2) const
| create a path between two configurations
| hpp::core::steeringMethod::Straight::Straight (const ProblemConstPtr_t &problem)
| hpp::core::steeringMethod::Straight::Straight (const Straight &other)
| Copy constructor.
void | hpp::core::steeringMethod::Straight::init (StraightWkPtr_t weak)
| Store weak pointer to itself.

## Detailed Description

Some system are subject to kinematic or dynamic constraints. Those constraints can be handled in path planning using a steering method that builds an admissible path between two configurations of the system. When using a steering method, it can be useful to use a distance function that accounts for the cost to go from a configuration to another.

## Function Documentation

## ◆ copy()

virtual SteeringMethodPtr_t hpp::core::steeringMethod::Straight::copy | ( |  | ) | const
| inlinevirtual

Copy instance and return shared pointer.

Implements hpp::core::SteeringMethod.

## ◆ create()

static StraightPtr_t hpp::core::steeringMethod::Straight::create | ( | const ProblemConstPtr_t & | problem | ) |
| inlinestatic

Create instance and return shared pointer.

## ◆ createCopy()

static StraightPtr_t hpp::core::steeringMethod::Straight::createCopy | ( | const StraightPtr_t & | other | ) |
| inlinestatic

Copy instance and return shared pointer.

## ◆ getWheelsFromParameter()

std::vector< JointPtr_t > hpp::core::steeringMethod::getWheelsFromParameter | ( | const ProblemConstPtr_t & | problem,
|  | const JointPtr_t & | rz
| ) |  |

## ◆ impl_compute()

virtual PathPtr_t hpp::core::steeringMethod::Straight::impl_compute | ( | ConfigurationIn_t | q1,
|  | ConfigurationIn_t | q2
| ) |  | const
| virtual

create a path between two configurations

Implements hpp::core::SteeringMethod.

## ◆ init()

void hpp::core::steeringMethod::Straight::init | ( | StraightWkPtr_t | weak | ) |
| inlineprotected

Store weak pointer to itself.

## ◆ reedsSheppPathOrDistance()

PathVectorPtr_t hpp::core::steeringMethod::reedsSheppPathOrDistance | ( | const DevicePtr_t & | device,
|  | ConfigurationIn_t | init,
|  | ConfigurationIn_t | end,
|  | value_type | extraLength,
|  | value_type | rho,
|  | size_type | xyId,
|  | size_type | rzId,
|  | const std::vector< JointPtr_t > | wheels,
|  | ConstraintSetPtr_t | constraints,
|  | bool | computeDistance,
|  | value_type & | distance
| ) |  |

Create a Reeds and Shepp path and return shared pointer

Parameters

  device | Robot corresponding to configurations,
  init,end | start and end configurations of the path,
  extraLength | the length of the path due to the non RS DoF,
  rho | The radius of a turn,
  xyId,rzId | indices in configuration vector of the joints corresponding to the translation and rotation of the car.

## ◆ Straight() [1/2]

hpp::core::steeringMethod::Straight::Straight | ( | const ProblemConstPtr_t & | problem | ) |
| inlineprotected

Constructor with robot Weighed distance is created from robot

## ◆ Straight() [2/2]

hpp::core::steeringMethod::Straight::Straight | ( | const Straight & | other | ) |
| inlineprotected

Copy constructor.